Package: SomaticCancerAlterations
Type: Package
Title: Somatic Cancer Alterations
Version: 1.48.0
Author: Julian Gehring
Maintainer: Julian Gehring <jg-bioc@gmx.com>
Imports: GenomicRanges, IRanges, S4Vectors
Depends: R (>= 3.5.0)
Suggests: testthat, ggbio, ggplot2, knitr
VignetteBuilder: knitr
Description: Collection of somatic cancer alteration datasets
License: GPL-3
LazyLoad: yes
biocViews: ExperimentData, Genome, CancerData, Project1000genomes, NCI
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/SomaticCancerAlterations
git_branch: RELEASE_3_23
git_last_commit: b0c3bfb
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-05-05
NeedsCompilation: no
Packaged: 2026-05-05 15:44:02 UTC; biocbuild

## ----echo=FALSE---------------------------------------------------------------
library(SomaticCancerAlterations)
library(GenomicRanges)
library(ggbio)

## ----list_datasets------------------------------------------------------------
all_datasets = scaListDatasets()
print(all_datasets)
meta_data = scaMetadata()
print(meta_data)

## ----load_dataset-------------------------------------------------------------
ov = scaLoadDatasets("ov_tcga", merge = TRUE)

## ----print--------------------------------------------------------------------
head(ov, 3)

## ----summary------------------------------------------------------------------
with(mcols(ov), table(Variant_Classification, Variant_Type))

## -----------------------------------------------------------------------------
head(sort(table(ov$Sample_ID), decreasing = TRUE))
head(sort(table(ov$Hugo_Symbol), decreasing = TRUE), 10)

## ----multiple_studies---------------------------------------------------------
three_studies = scaLoadDatasets(all_datasets[1:3])

print(elementNROWS(three_studies))

class(three_studies)

## ----merge_studies------------------------------------------------------------
merged_studies = scaLoadDatasets(all_datasets[1:3], merge = TRUE)

class(merged_studies)

## ----mutated_genes_study------------------------------------------------------
gene_study_count = with(mcols(merged_studies), table(Hugo_Symbol, Dataset))

gene_study_count = gene_study_count[order(apply(gene_study_count, 1, sum), decreasing = TRUE), ]

gene_study_count = addmargins(gene_study_count)

head(gene_study_count)

## ----subset_studies-----------------------------------------------------------
tp53_region = GRanges("17", IRanges(7571720, 7590863))

tp53_studies = subsetByOverlaps(merged_studies, tp53_region)

## ----variant_study_table------------------------------------------------------
addmargins(table(tp53_studies$Variant_Classification, tp53_studies$Dataset))

## ----mutateted_genes----------------------------------------------------------
fraction_mutated_region = function(y, region) {
    s = subsetByOverlaps(y, region)
    m = length(unique(s$Patient_ID)) / metadata(s)$Number_Patients
    return(m)
}

mutated_fraction = sapply(three_studies, fraction_mutated_region, tp53_region)

mutated_fraction = data.frame(name = names(three_studies), fraction =
mutated_fraction)

## ----plot_mutated_genes-------------------------------------------------------
library(ggplot2)

p = ggplot(mutated_fraction) + ggplot2::geom_bar(aes(x = name, y = fraction,
fill = name), stat = "identity") + ylim(0, 1) + xlab("Study") + ylab("Ratio") +
theme_bw()

print(p)

## ----echo=FALSE---------------------------------------------------------------
sessionInfo()

### read_maf ###
.read_maf <- function(path) {
    
    maf = read.delim(path, comment.char = "#", sep = "\t", header = TRUE, stringsAsFactors = TRUE)    

    return(maf)
}

### reconstruct_ids ###
.reconstruct_ids <- function(maf) {

    ## Extract the sample ID
    pattern = "(TCGA-.{2}-.{4})-.{3}-.{3}-.{4}-.{2}"
    #patient_ids = strtrim(maf$Tumor_Sample_Barcode, 12)
    maf$Sample_ID = factor(maf$Tumor_Sample_Barcode)
    maf$Patient_ID = factor(gsub(pattern, "\\1", maf$Tumor_Sample_Barcode))
  
    return(maf)
}


### maf2gr ###
.maf2gr <- function(maf, seq_info,
                    keep_columns = c("Hugo_Symbol", "Entrez_Gene_Id", "Variant_Classification", "Variant_Type", "Reference_Allele", "Tumor_Seq_Allele1", "Tumor_Seq_Allele2", "Verification_Status", "Validation_Status", "Mutation_Status", "Patient_ID", "Sample_ID") ) {
    
    ## The 'MT' is sometimes coded as 'M', rename this
    ## convert to NCBI notation
    maf$Chromosome = sub("^M$", "MT", maf$Chromosome)

    ## contruct GRanges
    maf$Strand = factor(as.character(maf$Strand), levels = c("+", "-", ".", "*"))
    gr = with(maf,
        GRanges(Chromosome, IRanges(Start_position, End_position), seqinfo = seq_info)
        )
    values(gr) = subset(maf, select = keep_columns)

    gr$index = 1:nrow(maf)

    gr = sort(gr) ## no 'unique', will ignore the data columns
    
    return(gr)
}


.meta_maf = function(maf, cancer = NA) {
    cancer_name = c(GBM = "Glioblastoma multiforme", HNSC = "Head and Neck squamous cell carcinoma", KIRC = "Kidney Chromophobe", LUAD = "Lung adenocarcinoma", LUSC = "Lung squamous cell carcinoma", OV = "Ovarian serous cystadenocarcinoma", SKCM = "Skin Cutaneous Melanoma", THCA = "Thyroid carcinoma ")
    strip_columns = c("Center", "NCBI_Build", "Sequence_Source", "Sequencing_Phase", "Sequencer")
    ## extract the meta data that is the same for all columns
    meta = sapply(strip_columns, function(column, data) {
        x = as.character(unique(data[[column]])) ## TODO: ugly, otherwise sapply will return the index of the factor
        if(length(x) != 1)
            warning(column)
        return(x)
        }, maf)
    meta$Number_Samples = nlevels(maf$Sample_ID)
    meta$Number_Patients = nlevels(maf$Patient_ID)
    meta = c(Cancer_Type = cancer, Cancer_Name = cancer_name[cancer], meta)

    return(meta)
}


### validate_maf ###
.validate_maf <- function(maf, seq_info, drop = FALSE) {

    ## a validator function per column
    validators = c(
        Chromosome = function(x) x %in% seqnames(seq_info),
        Strand = function(x) x %in% "+",
        Variant_Classification = function(x) x %in% c("Frame_Shift_Del", "Frame_Shift_Ins", "In_Frame_Del", "In_Frame_Ins", "Missense_Mutation", "Nonsense_Mutation", "Silent", "Splice_Site", "Translation_Start_Site", "Nonstop_Mutation", "3'UTR", "3'Flank", "5'UTR", "5'Flank", "IGR", "Intron", "RNA", "Targeted_Region"),
        Variant_Type = function(x) x %in% c("SNP", "DNP", "TNP", "ONP", "INS", "DEL", "Consolidated"),
        Reference_Allele = function(x) grepl("^[ACGT-]+$", x),
        Tumor_Seq_Allele1 = function(x) grepl("^[ACGT-]+$", x),
        Tumor_Seq_Allele2 = function(x) grepl("^[ACGT-]+$", x),
        Verification_Status = function(x) x %in% c("Verified", "Unknown", NA),
        Validation_Status = function(x) x %in% c("Untested", "Inconclusive", "Valid", "Invalid", NA),
        Sequencer = function(x) x %in% c("Illumina GAIIx", "Illumina HiSeq", "SOLID", "454", "ABI 3730xl", "Ion Torrent PGM", "Ion Torrent Proton", "PacBio RS", "Illumina MiSeq", "Illumina HiSeq 2500", "454 GS FLX Titanium", "AB SOLiD 4 System")
        )

    ## check each column
    idx_valid = logical(nrow(maf))
    idx_valid[] = TRUE
    for(n in names(validators)) {
        status = validators[[n]](maf[[n]])
        if(!all(status)) {
            idx_valid[status] = FALSE
            msg = sprintf("%s: %d invalid entries: '%s'", n, sum(!status), paste(head(as.character(maf[[n]][!status]), 3), collapse = ", "))
            warning(msg)
        }
    }

    ## return value
    if(drop)
        res = maf[idx_valid, ]
    else
        res = all(status)

    return(res)
}

library(SomaticCancerAlterations)
library(GenomicRanges)
library(IRanges)
library(stringr)
source("import-functions.R")

### parameters ###
open_access_cancer_types = c("GBM", "HNSC", "KIRC", "LUAD", "LUSC", "OV", "SKCM", "THCA")
#open_access_cancer_types = c("GBM", "HNSC", "KIRC", "LUAD", "LUSC", "OV", "SKCM", "THCA", "UCEC")
import_cancer_types = open_access_cancer_types[!grepl("UCEC", open_access_cancer_types)] ## ignore 'UCEC' at the moment

data_dir = "/ebi/research/huber/users/jgehring/projects/28-cbioportal/code/package/SomaticCancerAlterations/data"
dir.create(data_dir, showWarnings = FALSE)

base_regexp = "(.*)_([A-Z]{2,7}).(.*)_(.*).Level_(\\d+.\\d+.\\d+.\\d+)"
base_names = c("institute", "cancer", "sequencer", "source", "version")


### find the maf files ###

maf_dir = "/ebi/research/huber/users/jgehring/projects/28-cbioportal/data/tcga/mutations/maf/new"
maf_select_pattern = ".*broad.mit.edu.*.maf$" ## only import 'broad' studies
maf_paths = dir(path = maf_dir, pattern = ".*.maf", recursive = TRUE, full.names = TRUE)

seq_info_path = "/ebi/research/huber/users/jgehring/projects/28-cbioportal/data/tcga/hs37d5_seq_info.Rda"

maf_select_paths = grep(maf_select_pattern, maf_paths, value = TRUE)
maf_select_paths = sapply(import_cancer_types, grep, maf_select_paths, value = TRUE)

### meta data from path names ###
study_base = basename(dirname(maf_select_paths))
studies = str_match(study_base, base_regexp)[ ,-1] ## ignore full match
colnames(studies) = base_names

#stopifnot(!anyDuplicated())

names(maf_select_paths) = studies[ ,"cancer"]

load(seq_info_path)

meta_list = list()
for(i in seq_along(maf_select_paths)) {
    cancer = names(maf_select_paths)[i]
    print(cancer)
    var_name = sprintf("%s_tcga", tolower(cancer))
    save_path = file.path(data_dir, sprintf("%s.rda", var_name))
    maf = .read_maf(maf_select_paths[i])
    stopifnot(.validate_maf(maf, seq_info_hs37d5))
    maf = .reconstruct_ids(maf)
    meta_list[[var_name]] = .meta_maf(maf, cancer)
    gr = .maf2gr(maf, seq_info_hs37d5)
    metadata(gr) = meta_list[[var_name]]
    assign(var_name, gr)
    save(file = save_path,
         list = c(var_name))
}

meta = as.data.frame(t(sapply(meta_list, c)))
names(meta) = names(meta)

save_path = file.path(data_dir, "meta.rda")
save(file = save_path, "meta")

scaListDatasets <- function() {
    x = data(package = "SomaticCancerAlterations")$results[ ,"Item"]
    x = x[(x != "meta")]
    return(x)
}

scaLoadDatasets <- function(names, merge = FALSE) {
    all_datasets = scaListDatasets()
    if(missing(names))
        names = all_datasets
    if(!all(idx <- names %in% all_datasets)) {
        msg = sprintf("Data set %s not found.",
            paste(names[!idx], collapse = ", "))
        stop(msg)
    }
    
    x = sapply(names, .load_dataset, simplify = FALSE, USE.NAMES = TRUE)
    res = GRangesList(unlist(x), compress=FALSE)
    if(merge) {
        datasets = rep(factor(rep(names(res), lengths(res))))
        res = unlist(res)
        res$Dataset = datasets
    }

    return(res)
}

scaMetadata <- function() {
    res = .load_dataset("meta")
    return(res)
}
    
  
.load_dataset <- function(name, package = "SomaticCancerAlterations") {
    tmp_env = new.env()
    data(list = name, package = package, envir = tmp_env)
    res = get(name, envir = tmp_env)
    return(res)
}


ncbi2hg <- function(x) {
    seqnameStyle(x) = "ucsc"
    genome(x) = NA
    return(x)
}


hg2ncbi <- function(x) {
    seqnameStyle(x) = "ncbi"
    genome(x) = NA
    return(x)
}


seqchr <- function(x) {
    y = as.character(seqnames(x))
    return(y)
}

library(testthat)
library(SomaticCancerAlterations)

context("Accessor functions")
  
test_that("'scaListDatasets' works", {
      
    expect_is( class(scaListDatasets()), "character" )
    expect_error( scaListDatasets(1) )
    
})

test_that("'scaLoadDatasets' works", {

    all_datasets = scaListDatasets()
    ds = sample(all_datasets, 1)
    ds2 = sample(all_datasets, 2)

    expect_is( scaLoadDatasets(ds), "GRangesList" )
    expect_is( scaLoadDatasets(ds, merge = FALSE), "GRangesList" )
    expect_is( scaLoadDatasets(ds, merge = TRUE), "GRanges" )
    expect_is( scaLoadDatasets(ds2), "GRangesList" )
    expect_is( scaLoadDatasets(ds2, merge = FALSE), "GRangesList" )
    expect_is( scaLoadDatasets(ds2, merge = TRUE), "GRanges" )
    expect_identical( length(scaLoadDatasets()), length(all_datasets) )
      
    expect_error( scaLoadDatasets("not_present") )
    expect_error( scaLoadDatasets(c(all_datasets, "not_present")) )

    x = scaLoadDatasets(all_datasets[1:2], merge = FALSE)
    expect_identical( names(x), all_datasets[1:2] )

    for(ds in all_datasets) {
        x = scaLoadDatasets(ds, merge = TRUE)
        expect_true( length(x) > 0 )
        expect_is( x$Sample_ID, "factor" )
        expect_is( x$Patient_ID, "factor" )
    }

})

test_that("'scaMetadata' works", {
    
    expect_is( scaMetadata(), "data.frame" )
    expect_error( scaMetadata(1) )
    expect_equal( sort(scaListDatasets()), sort(rownames(scaMetadata())) )
    
})

test_that("'mutationDensity' works", {
    
    ds = sample(scaListDatasets(), 1)  
    x = scaLoadDatasets(ds, merge = TRUE)

    expect_is( mutationDensity(x, 1e8), "GRanges" )
    expect_is( mutationDensity(x, binSize = 1e8), "GRanges" )
    
})

#LyX 2.0 created this file. For more info see http://www.lyx.org/
\lyxformat 413
\begin_document
\begin_header
\textclass article
\begin_preamble
%\VignetteIndexEntry{SomaticCancerAlterations package}
%\VignettePackage{SomaticCancerAlterations}

% To compile this document
% library('cacheSweave'); rm(list=ls()); Sweave('DESeq2.Rnw', driver=cacheSweaveDriver())

<<style, eval=TRUE, echo=FALSE, results=tex>>=
BiocStyle::latex()
@

%\usepackage{Sweave}
\setkeys{Gin}{width=0.5\textwidth}

% use a vertical rule for R output instead of prompts for R input
%\usepackage{fancyvrb}
%\definecolor{darkgray}{gray}{0.2}
%\DefineVerbatimEnvironment{Sinput}{Verbatim}{xleftmargin=1em,formatcom={\color{darkgray}}}
%\DefineVerbatimEnvironment{Soutput}{Verbatim}{xleftmargin=1em,frame=leftline,framerule=.6pt,rulecolor=\color{darkgray},framesep=1em,formatcom={\color{darkgray}}}
%\fvset{listparameters={\setlength{\topsep}{0pt}}}
%\renewenvironment{Schunk}{\vspace{\topsep}}{\vspace{\topsep}}
\end_preamble
\use_default_options false
\begin_modules
sweave
\end_modules
\maintain_unincluded_children false
\language english
\language_package default
\inputencoding utf8
\fontencoding global
\font_roman default
\font_sans default
\font_typewriter default
\font_default_family default
\use_non_tex_fonts false
\font_sc false
\font_osf false
\font_sf_scale 100
\font_tt_scale 100

\graphics default
\default_output_format default
\output_sync 0
\bibtex_command default
\index_command default
\paperfontsize default
\spacing single
\use_hyperref false
\pdf_bookmarks false
\pdf_bookmarksnumbered false
\pdf_bookmarksopen false
\pdf_bookmarksopenlevel 1
\pdf_breaklinks false
\pdf_pdfborder false
\pdf_colorlinks false
\pdf_backref false
\pdf_pdfusetitle false
\papersize a4paper
\use_geometry false
\use_amsmath 1
\use_esint 1
\use_mhchem 1
\use_mathdots 1
\cite_engine basic
\use_bibtopic false
\use_indices false
\paperorientation portrait
\suppress_date false
\use_refstyle 0
\index Index
\shortcut idx
\color #008000
\end_index
\secnumdepth 3
\tocdepth 3
\paragraph_separation skip
\defskip smallskip
\quotes_language english
\papercolumns 1
\papersides 1
\paperpagestyle default
\tracking_changes false
\output_changes false
\html_math_output 0
\html_css_as_file 0
\html_be_strict false
\end_header

\begin_body

\begin_layout Title
The 
\begin_inset ERT
status open

\begin_layout Plain Layout


\backslash
Biocpkg{SomaticCancerAlterations}
\end_layout

\end_inset

 package
\end_layout

\begin_layout Author
Julian Gehring, EMBL Heidelberg
\end_layout

\begin_layout Chunk
<<settings, echo=FALSE>>=
\end_layout

\begin_layout Chunk
set.seed(1)
\end_layout

\begin_layout Chunk
options(width=65)
\end_layout

\begin_layout Chunk
@
\end_layout

\begin_layout Section
Motivation
\end_layout

\begin_layout Standard
Over the last years, large efforts have been taken to characterize the somatic
 landscape of cancers.
 Many of the conducted studies make their results publicly available, providing
 a valuable resource for investigating beyond the level of individual cohorts.
 The 
\begin_inset ERT
status open

\begin_layout Plain Layout


\backslash
Biocpkg{SomaticCancerAlterations}
\end_layout

\end_inset

 package collects mutational data of several tumor types, currently focusing
 on the TCGA calls sets, and aims for a tight integration with 
\begin_inset ERT
status open

\begin_layout Plain Layout


\backslash
R{}
\end_layout

\end_inset

 and 
\begin_inset ERT
status open

\begin_layout Plain Layout


\backslash
Bioconductor{}
\end_layout

\end_inset

 workflows.
 In the following, we will illustrate how to access this data and give examples
 for use cases.
\end_layout

\begin_layout Chunk
<<load_package, echo=FALSE>>=
\end_layout

\begin_layout Chunk
library(SomaticCancerAlterations)
\end_layout

\begin_layout Chunk
library(GenomicRanges)
\end_layout

\begin_layout Chunk
library(ggbio)
\end_layout

\begin_layout Chunk
@
\end_layout

\begin_layout Section
Data Sets
\end_layout

\begin_layout Standard
The Cancer Genome Atlas (TCGA)
\begin_inset Foot
status open

\begin_layout Plain Layout
\begin_inset Flex URL
status collapsed

\begin_layout Plain Layout

http://cancergenome.nih.gov
\end_layout

\end_inset


\end_layout

\end_inset

 is a consortium effort to analyze a variety of tumor types, including gene
 expression, methylation, copy number changes, and somatic mutations
\begin_inset Foot
status open

\begin_layout Plain Layout
\begin_inset Flex URL
status collapsed

\begin_layout Plain Layout

https://wiki.nci.nih.gov/display/TCGA/TCGA+Home
\end_layout

\end_inset


\end_layout

\end_inset

.
 With the 
\begin_inset ERT
status open

\begin_layout Plain Layout


\backslash
Biocpkg{SomaticCancerAlterations}
\end_layout

\end_inset

 package, we provide the callsets of somatic mutations for all publically
 available TCGA studies.
 Over time, more studies will be added, as they become available and unrestriced
 in their usage.
\end_layout

\begin_layout Standard
To get started, we get a list of all available data sets and access the
 metadata associated with each study.
 
\end_layout

\begin_layout Chunk
<<list_datasets>>=
\end_layout

\begin_layout Chunk
all_datasets = scaListDatasets()
\end_layout

\begin_layout Chunk
print(all_datasets)
\end_layout

\begin_layout Chunk
meta_data = scaMetadata()
\end_layout

\begin_layout Chunk
print(meta_data)
\end_layout

\begin_layout Chunk
@
\end_layout

\begin_layout Standard
Next, we load a single dataset with the 
\begin_inset ERT
status open

\begin_layout Plain Layout


\backslash
Rfunction{sca
\backslash
_load
\backslash
_dataset}
\end_layout

\end_inset

 function.
\end_layout

\begin_layout Chunk
<<load_dataset>>=
\end_layout

\begin_layout Chunk
ov = scaLoadDatasets("ov_tcga", merge = TRUE)
\end_layout

\begin_layout Chunk
@
\end_layout

\begin_layout Section
Exploring Mutational Data
\end_layout

\begin_layout Standard
The somatic variants of each study are represented as a 
\begin_inset ERT
status open

\begin_layout Plain Layout


\backslash
Rclass{GRanges}
\end_layout

\end_inset

 object, ordered by genomic positions.
 Additional columns describe properties of the variant and relate it the
 the affected gene, sample, and patient.
\end_layout

\begin_layout Chunk
<<print>>=
\end_layout

\begin_layout Chunk
head(ov, 3)
\end_layout

\begin_layout Chunk
@
\end_layout

\begin_layout Chunk
<<summary>>=
\begin_inset Newline newline
\end_inset

with(mcols(ov), table(Variant_Classification, Variant_Type))
\end_layout

\begin_layout Chunk
@
\end_layout

\begin_layout Standard
With such data at hand, we can identify the samples and genes haboring the
 most mutations.
\end_layout

\begin_layout Chunk
<<tables>>=
\end_layout

\begin_layout Chunk
head(sort(table(ov$Sample_ID), decreasing = TRUE))
\end_layout

\begin_layout Chunk
head(sort(table(ov$Hugo_Symbol), decreasing = TRUE), 10)
\end_layout

\begin_layout Chunk
@
\end_layout

\begin_layout Section
Exploring Multiple Studies
\end_layout

\begin_layout Standard
Instead of focusing on an individual study, we can also import several at
 once.
 The results are stored as a 
\begin_inset ERT
status open

\begin_layout Plain Layout


\backslash
Rclass{GRangesList}
\end_layout

\end_inset

 in which each element corresponds to a single study.
 This can be merged into a single 
\begin_inset ERT
status open

\begin_layout Plain Layout


\backslash
Rclass{GRanges}
\end_layout

\end_inset

 object with 
\begin_inset ERT
status open

\begin_layout Plain Layout


\backslash
Rcode{merge = TRUE}
\end_layout

\end_inset

.
\end_layout

\begin_layout Chunk
<<multiple_studies>>=
\end_layout

\begin_layout Chunk
three_studies = scaLoadDatasets(all_datasets[1:3])
\end_layout

\begin_layout Chunk
print(elementNROWS(three_studies))
\end_layout

\begin_layout Chunk
class(three_studies)
\end_layout

\begin_layout Chunk
@
\end_layout

\begin_layout Chunk
<<merge_studies>>=
\end_layout

\begin_layout Chunk
merged_studies = scaLoadDatasets(all_datasets[1:3], merge = TRUE)
\end_layout

\begin_layout Chunk
class(merged_studies)
\end_layout

\begin_layout Chunk
@
\end_layout

\begin_layout Standard
We then compute the number of mutations per gene and study:
\end_layout

\begin_layout Chunk
<<mutated_genes_study>>=
\end_layout

\begin_layout Chunk
gene_study_count = with(mcols(merged_studies), table(Hugo_Symbol, Dataset))
\end_layout

\begin_layout Chunk
gene_study_count = gene_study_count[order(apply(gene_study_count, 1, sum),
 decreasing = TRUE), ]
\end_layout

\begin_layout Chunk
gene_study_count = addmargins(gene_study_count)
\end_layout

\begin_layout Chunk
head(gene_study_count)
\end_layout

\begin_layout Chunk
@
\end_layout

\begin_layout Standard
Further, we can subset the data by regions of interests, and compute descriptive
 statistics only on the subset.
\end_layout

\begin_layout Chunk
<<subset_studies>>=
\end_layout

\begin_layout Chunk
tp53_region = GRanges("17", IRanges(7571720, 7590863))
\end_layout

\begin_layout Chunk
tp53_studies = subsetByOverlaps(merged_studies, tp53_region)
\end_layout

\begin_layout Chunk
@
\end_layout

\begin_layout Standard
For example, we can investigate which type of somatic variants can be found
 in TP53 throughout the studies.
\end_layout

\begin_layout Chunk
<<variant_study_table>>=
\end_layout

\begin_layout Chunk
addmargins(table(tp53_studies$Variant_Classification, tp53_studies$Dataset))
\end_layout

\begin_layout Chunk
@
\end_layout

\begin_layout Standard
To go further, how many patients have mutations in TP53 for each cancer
 type?
\end_layout

\begin_layout Chunk
<<mutateted_genes>>=
\end_layout

\begin_layout Chunk
fraction_mutated_region = function(y, region) {
\end_layout

\begin_layout Chunk
	s = subsetByOverlaps(y, region)
\end_layout

\begin_layout Chunk
	m = length(unique(s$Patient_ID)) / metadata(s)$Number_Patients
\end_layout

\begin_layout Chunk
	return(m)
\end_layout

\begin_layout Chunk
}
\end_layout

\begin_layout Chunk
mutated_fraction = sapply(three_studies, fraction_mutated_region, tp53_region)
\end_layout

\begin_layout Chunk
mutated_fraction = data.frame(name = names(three_studies), fraction = mutated_fra
ction)
\end_layout

\begin_layout Chunk
@
\end_layout

\begin_layout Chunk
<<plot_mutated_genes, fig=TRUE, echo=TRUE, include=FALSE>>=
\end_layout

\begin_layout Chunk
library(ggplot2)
\end_layout

\begin_layout Chunk
p = ggplot(mutated_fraction) + ggplot2::geom_bar(aes(x = name, y = fraction,
 fill = name), stat = "identity") + ylim(0, 1) + xlab("Study") + ylab("Ratio")
 + theme_bw()
\end_layout

\begin_layout Chunk
print(p)
\end_layout

\begin_layout Chunk
@
\end_layout

\begin_layout Standard
\begin_inset ERT
status open

\begin_layout Plain Layout


\backslash
incfig{SomaticCancerAlterations-plot_mutated_genes}{0.75
\backslash
textwidth}{Summary for TP53}{The fraction of patients with somatic mutations
 in TP53, for each study individually.}
\end_layout

\end_inset


\end_layout

\begin_layout Section
Data Provenance
\end_layout

\begin_layout Subsection
TCGA Data
\end_layout

\begin_layout Standard
When importing the mutation data from the TCGA servers, we checked the data
 for consistency and fix common ambiguities in the annotation.
\end_layout

\begin_layout Subsubsection
Processing
\end_layout

\begin_layout Enumerate
Selection of the most recent somatic variant calls for each study.
 These were stored as '*.maf' files in the TCGA data directory
\begin_inset Foot
status collapsed

\begin_layout Plain Layout
\begin_inset Flex URL
status collapsed

\begin_layout Plain Layout

https://tcga-data.nci.nih.gov/tcgafiles/ftp_auth/distro_ftpusers/anonymous/tumor/
\end_layout

\end_inset


\end_layout

\end_inset

.
 If both manually curated and automatically generated variant calls were
 available, the curated version was chosen.
\end_layout

\begin_layout Enumerate
Importing of the '*.maf' files into R and checking for consistency with the
 TCGA MAF specifications
\begin_inset Foot
status collapsed

\begin_layout Plain Layout
\begin_inset Flex URL
status open

\begin_layout Plain Layout

https://wiki.nci.nih.gov/display/TCGA/Mutation+Annotation+Format+(MAF)+Specificatio
n
\end_layout

\end_inset


\end_layout

\end_inset

.
 Please note that these guidelines are currently only suggestions and most
 TCGA files violate some of these.
\end_layout

\begin_layout Enumerate
Transformation of the imported variants into a 'GRanges' object, with one
 row for each reported variant.
 Only columns related to the genomic origin of the somatic variant were
 stored, additional columns describing higher-level effects, such as mutational
 consequences and alterations at the protein level, were dropped.
 The 
\begin_inset ERT
status open

\begin_layout Plain Layout


\backslash
Robject{seqlevels}
\end_layout

\end_inset

 information defining the chromosomal ranges were taken from the 1000genomes
 phase 2 reference assembly
\begin_inset Foot
status collapsed

\begin_layout Plain Layout
\begin_inset Flex URL
status collapsed

\begin_layout Plain Layout

ftp://ftp.1000genomes.ebi.ac.uk/vol1/ftp/technical/reference/phase2_reference_assemb
ly_sequence/
\end_layout

\end_inset


\end_layout

\end_inset

.
\end_layout

\begin_layout Enumerate
The patient barcode was extracted from the sample barcode.
\end_layout

\begin_layout Enumerate
Metadata describing the design and analysis of the study was extracted.
\end_layout

\begin_layout Enumerate
The processed variants were written to disk, with one file for each study.
 The metadata for all studies were stored as a single, separate object.
\end_layout

\begin_layout Subsubsection
Selection Criteria of Data Sets
\end_layout

\begin_layout Standard
We included data sets in the package that were
\end_layout

\begin_layout Itemize
conducted by the Broad Institute.
\end_layout

\begin_layout Itemize
cleared for unrestricted access and usage
\begin_inset Foot
status collapsed

\begin_layout Plain Layout
\begin_inset Flex URL
status collapsed

\begin_layout Plain Layout

http://cancergenome.nih.gov/abouttcga/policies/publicationguidelines
\end_layout

\end_inset


\end_layout

\end_inset

.
\end_layout

\begin_layout Itemize
sequenced with Illumina platforms.
\end_layout

\begin_layout Subsubsection
Consistency Check
\end_layout

\begin_layout Standard
According to the TCGA specifications for the 'MAF' files, we screened and
 corrected for common artifacts in the data regarding annotation.
 This included:
\end_layout

\begin_layout Itemize
Transfering of all genomic coordinates to the NCBI 37 reference notation
 (with the chromosome always depicted as 'MT')
\end_layout

\begin_layout Itemize
Checking of the entries against all allowed values for this field (currently
 for the columns 
\emph on
Hugo_Symbol
\emph default
, 
\emph on
Chromosome
\emph default
, 
\emph on
Strand
\emph default
, 
\emph on
Variant_Classification
\emph default
, 
\emph on
Variant_Type
\emph default
, 
\emph on
Reference_Allele
\emph default
, 
\emph on
Tumor_Seq_Allele1
\emph default
, 
\emph on
Tumor_Seq_Allele2
\emph default
, 
\emph on
Verification_Status
\emph default
, 
\emph on
Validation_Status
\emph default
, 
\emph on
Sequencer
\emph default
).
\end_layout

\begin_layout Section
Alternatives
\end_layout

\begin_layout Standard
The TCGA data sets can be accessed in different ways.
 First, the 
\emph on
TCGA
\emph default
 itself offers access to certain types of its collected data
\begin_inset Foot
status collapsed

\begin_layout Plain Layout
\begin_inset Flex URL
status collapsed

\begin_layout Plain Layout

https://tcga-data.nci.nih.gov/tcga/tcgaDownload.jsp
\end_layout

\end_inset


\end_layout

\end_inset

.
 Another approach has been taken by the 
\emph on
cBioPortal for Cancer Genomics
\emph default

\begin_inset Foot
status collapsed

\begin_layout Plain Layout
\begin_inset Flex URL
status collapsed

\begin_layout Plain Layout

http://www.cbioportal.org/public-portal/
\end_layout

\end_inset


\end_layout

\end_inset

 which has performed high-level analyses of several TCGA data sources, such
 as gene expression and copy number changes.
 This summarized data can be queried through an R interface
\begin_inset Foot
status collapsed

\begin_layout Plain Layout
\begin_inset Flex URL
status collapsed

\begin_layout Plain Layout

http://www.cbioportal.org/public-portal/cgds_r.jsp
\end_layout

\end_inset


\end_layout

\end_inset

.
\end_layout

\begin_layout Standard
\begin_inset Newpage newpage
\end_inset


\end_layout

\begin_layout Section*
Session info
\end_layout

\begin_layout Chunk
<<sessionInfo, results=tex, echo=FALSE>>=
\end_layout

\begin_layout Chunk
toLatex(sessionInfo(), locale=FALSE)
\end_layout

\begin_layout Chunk
@
\end_layout

\end_body
\end_document

\name{SomaticCancerAlterations-package}
     
\docType{package}

\alias{SomaticCancerAlterations}
\alias{SomaticCancerAlterations-package}

\title{Somatic Cancer Alterations}

\description{
  A collection of studies with somatic cancer alterations.
}

\details{
  The 'SomaticCancerAlterations' package provides a collection of the
  mutational calls for different cancer studies, aiming for a tight
  integration with R and Bioconductor.  At the moment, this covers
  somatic single nucleotide variants (SNVs) and indels for several TCGA
  studies.  Over time, this colletion will be updated to include additional
  studies.
  
  The Cancer Genome Atlas (TCGA) is a consortium effort to analyze a
  variety of tumor types at multiple levels, including gene
  expression, methylation, copy number alterations and somatic
  mutations [\url{http://cancergenome.nih.gov}]. Most of this data is
  publically available, and offers a rich resource in understanding
  cancer-related data sets and experiments
  [\url{https://wiki.nci.nih.gov/display/TCGA/TCGA+Home}].
}

\references{
  \url{https://tcga-data.nci.nih.gov/tcga/}
  
  \url{https://tcga-data.nci.nih.gov/docs/publications/}
}

\author{
  Julian Gehring, with suggestions and contributions
  from Bernd Fischer
  
  Maintainer: Julian Gehring
}
   
\seealso{
  \code{\link[SomaticCancerAlterations]{SomaticCancerAlterations-functions}}
  
  \code{\link[SomaticCancerAlterations]{SomaticCancerAlterations-data}}
 }
 
\keyword{package}
\keyword{datasets}

\name{SomaticCancerAlterations-functions}
    
\alias{SomaticCancerAlterations-functions}

\alias{scaListDatasets}
\alias{scaLoadDatasets}
\alias{scaMetadata}

\title{SomaticCancerAlterations functions}

\description{
  Functions to interact with the 'SomaticCancerAlterations' datasets.
}

\usage{
scaMetadata()

scaListDatasets()

scaLoadDatasets(names, merge = FALSE)
}

\arguments{
  \item{names}{Character vector with data set name(s) to load. The names
    are the same as returned from 'scaListDatasets()'.}
  \item{merge}{Logical.  Should the results be a merged 'GRanges' object
  with data of all studies (TRUE), or a 'GRangesList' with one list
  element per dataset (FALSE [default]).}
}

\value{
  \item{scaMetadata}{A data frame summarizing the available data
    sets, with rows corresponding to data sets.}
  \item{scaListDatasets}{A character vector with all available study
    names.}
  \item{sca_load_dataset}{A GRangesList or GRanges objecs, depending
    on the 'merge' argument.}
}

\details{
  The 'sca_load_dataset' function makes it easy to load the data of a study
  directly into a variable.
}
  
\references{
  \url{https://tcga-data.nci.nih.gov/tcga/}
  
  \url{https://wiki.nci.nih.gov/display/TCGA/TCGA+Data+Primer}
  
  \url{https://tcga-data.nci.nih.gov/tcgafiles/ftp_auth/distro_ftpusers/anonymous/tumor/}
}

\seealso{
  \code{\link[SomaticCancerAlterations]{SomaticCancerAlterations-data}}
}

\examples{
meta_data = scaMetadata()
head(meta_data)

all_datasets = scaListDatasets()
head(all_datasets)

grl = scaLoadDatasets(all_datasets[1], merge = FALSE)

gr = scaLoadDatasets(all_datasets[1], merge = TRUE)
}

\name{SomaticCancerAlterations-helper-functions}
     
\alias{SomaticCancerAlterations-helper-functions}

\alias{ncbi2hg}
\alias{hg2ncbi}
\alias{seqchr}

\title{SomaticCancerAlterations helper functions}

\description{
  Functions to help with common analysis tasks.
}

\usage{
ncbi2hg(x)
 
hg2ncbi(x)
 
seqchr(x)
}

\arguments{
  \item{x}{A GRanges object}
}

\value{
  \item{ncbi2hg, hg2ncbi}{A GRanges object.}
  \item{seqchr}{A character vector with the 'seqnames'.}
}
 
\details{
  These functions provide useful wrappers for converting between genomic
  coordinate systems and classes.
}

\name{SomaticCancerAlterations-data}

\docType{data}

\alias{SomaticCancerAlterations-data}

\alias{meta}
\alias{blca_tcga}
\alias{cesc_tcga}
\alias{gbm_tcga}
\alias{hnsc_tcga}
\alias{kirc_tcga}
\alias{lgg_tcga}
\alias{luad_tcga}
\alias{lusc_tcga}
\alias{ov_tcga}
\alias{paad_tcga}
\alias{prad_tcga}
\alias{skcm_tcga}
\alias{stad_tcga}
\alias{thca_tcga}
\alias{ucec_tcga}

\title{Somatic Cancer Alterations Data Sets}

\description{
  Data sets with studies of somatic cancer alterations.
}

\value{
  A 'GRanges' object for each study.  Each row corresponds to a somatic
  variant reported in the respective study, with the coordinates
  refering to the location on the reference genome.  
}

\details{
  Currently, the data sets include somatic mutations (SNVs and indels)
  of the publically available TCGA studies.  Further studies will be
  included in the future.
  
  For details on the TCGA mutation calls, please see the TCGA documentation
  \url{https://wiki.nci.nih.gov/display/TCGA/TCGA+Data+Primer}.  Please
  note that the mutational calling was performed by different centers.  The
  original '*.maf' files can be obtained from the TCGA data portal
  \url{https://tcga-data.nci.nih.gov/tcgafiles/ftp_auth/distro_ftpusers/anonymous/tumor/}.

  After importing, the data is automatically processed to improve
  consistency across studies and remove common
  artifacts in the annotation.  The most obvious changes are:

  \itemize{
    \item{Only studies cleared for unrestricted usage are included (see
      \url{http://cancergenome.nih.gov/publications/publicationguidelines}).}
    \item{Only studies processed by the Broad Instutite are considered
      at the moment.}
    \item{All variants located on the mitochondrium are mapped to the
      sequence identifier 'MT' (note that the original files contain both
      'MT' and 'M' mixed).}
    \item{All locations are now consistent with the 1000genomes reference
      sequence (NCBI37 coordinates).}
  }

  About the TCGA data:

  \dQuote{All data generated by The Cancer Genome Atlas (TCGA) Research Network
  are made open to the public through the Data Coordinating Center and
  the TCGA Data Portal.}  For details on the usage of the data, please
  have a look at
  \url{http://cancergenome.nih.gov/abouttcga/policies/publicationguidelines}.
}
  
\references{
  \url{https://tcga-data.nci.nih.gov/tcga/}
}

\seealso{
  \code{\link[SomaticCancerAlterations]{SomaticCancerAlterations-functions}}

  \code{\link[SomaticCancerAlterations]{SomaticCancerAlterations-package}}
}

\examples{
all_datasets = scaListDatasets()
grl = scaLoadDatasets(all_datasets[1])
}

\keyword{datasets}
